/*
 * AdminThread.java
 *
 * Created on July 31, 2003, 5:19 PM
 */

package SrvrTmplt;
import java.io.*;
import java.net.*;
import java.lang.*;
/**
 *
 * @author  Mohamed Medhat (www.digitalcairo.com)
 * @version 1.0
 */
public class AdminThread extends Thread {

    static String AdminCmd;
    
    final String PromptMsg = "Server> ";
    
    final String AdminHelpMsg = "Available admin commands are: help, version, start, stop, restart, disconnect, prtstngs, prtmsgs, prtstats, confstngs, confmsgs, and quit.\nUse longhelp for a detailed description of each command.";
    
    int NumOfSessions;
    
    /** Creates new AdminThread */
    public AdminThread() {
    }

    private void ListSessions() {
        if (SrvrMain.NumOfSrvrThreads == 0)
            System.out.println("\nCurrent number of active connections = " + SrvrMain.NumOfSrvrThreads + "\n");
        else
        {
            System.out.println("\nCurrent number of active connections = " + SrvrMain.NumOfSrvrThreads + "\n");
            NumOfSessions = 1;
            System.out.println("Session Number\tUser IP Address\t");
            while (NumOfSessions <= SrvrMain.NumOfSrvrThreads)
            {
                 try {
                    
               System.out.println(NumOfSessions + "\t\t" + SrvrMain.ClientsIPs[NumOfSessions - 1].getHostAddress() );
                    
                    
                }
                 
                catch (NullPointerException e)
                {
                 System.out.println(e.getMessage());   
                }

                NumOfSessions++;
            }
            System.out.println("");
        }
    }
    
    private void restartSrvr() {
        if (SrvrMain.SrvrRunning == true)
        SrvrMain.stopSrvr();
        SrvrMain.StartSrvr = true;

    }
    
    private void PrintSettings() {
        System.out.println("");
        System.out.println("Server settings:");
        System.out.println("");        
        System.out.println("Version = " + SrvrMain.VersionMsg);
        System.out.println("Server listening port = " + SrvrMain.SrvrPort);
        System.out.println("Maximum number of connections allowed = " + SrvrMain.MaxConnNum);
        System.out.println("Client Timeout ( in seconds) = " + SrvrMain.ClientTimeOut);
        System.out.println("Database path = " + SrvrMain.DBPath);
        System.out.println("Log file path = " + SrvrMain.LogPath + "\n");

        
    }
    
    public static void DisconnectAll() {
        int i;
        if (SrvrMain.NumOfSrvrThreads == 0)
            System.out.println("0 current connections.");
        else
        {

        try { 
           for (i = 0 ; i < SrvrMain.NumOfSrvrThreads ; i++)
           {
        SrvrMain.ClientSock[i].close();
           }
        }
        catch (IOException e) {}
        System.out.println("All sessions has been disconnected.\n");
        }
    }
    
    public void run() {

//DataInputStream newin = new DataInputStream(System.in);
        BufferedReader newin;
        newin = new BufferedReader(new InputStreamReader(System.in));
        System.out.println("\n" + SrvrMain.VersionMsg);
        System.out.println("\n" + AdminHelpMsg + "\n");
        System.out.print(PromptMsg);
        try {

        AdminCmd = newin.readLine();
        }
        catch (IOException e) {
            System.out.println(e.getMessage());
        }
        while (AdminCmd != "quit")
        {
                if (AdminCmd.equals(null))
                System.out.println("Unknown command.");
                else if (AdminCmd.equals("help"))
                System.out.println("\n" + AdminHelpMsg + "\n");
                else if (AdminCmd.equalsIgnoreCase("version"))
                System.out.println("\n" + SrvrMain.VersionMsg + "\n");
                else if (AdminCmd.equalsIgnoreCase("start"))
                SrvrMain.StartSrvr = true;
                else if (AdminCmd.equalsIgnoreCase("stop"))
                SrvrMain.stopSrvr();
                else if (AdminCmd.equalsIgnoreCase("restart"))
                restartSrvr();                
                else if (AdminCmd.equalsIgnoreCase("prtstngs"))
                PrintSettings();
                else if (AdminCmd.equalsIgnoreCase("prtstats"))                 
                PrintStatus();
                else if (AdminCmd.equalsIgnoreCase("prtmsgs"))
                PrintMsgs();
                else if (AdminCmd.equalsIgnoreCase("confstngs"))
                ConfigSettings();
                else if (AdminCmd.equalsIgnoreCase("confmsgs"))
                ConfigMsgs();                 
                else if (AdminCmd.equalsIgnoreCase("disconnect"))
                DisconnectAll();  
                else if (AdminCmd.equals("quit"))
                {
                if (SrvrMain.SrvrRunning == true)
                {
                System.out.println("\nShutting down service.");
                SrvrMain.stopSrvr();
                }
                SrvrMain.KillSrvr = true;
                System.out.println("Killing process.\nDone.\n");
                break;
                }
                else if (AdminCmd.equalsIgnoreCase("longhelp"))
                    AdminLongHelp();
                else System.out.println("\nUnknown command, use help or longhelp for available commands.\n");
        System.out.print(PromptMsg);
        try {
        AdminCmd = newin.readLine();

        }
        catch (IOException e) {
            System.out.println(e.getMessage());
        }
        }
        try {
        newin.close();
        }
        catch (IOException e) {
            System.out.println(e.getMessage());
        }
      try {
        this.join();
      }
      catch (InterruptedException e) 
      {
          System.out.println(e.getMessage());
      }
    }
    
    private void PrintStatus() {
        System.out.println("\nServer status:");
        System.out.println("");        
        System.out.println("Server running = " + SrvrMain.SrvrRunning);
        ListSessions();
    }
    
    public void PrintMsgs() {
        System.out.println("\nServer Messages:");
        System.out.println(" ");
        System.out.println("Welcome message = " + SrvrMain.WelcomeMsg);
        System.out.println("Disconnection message = " + SrvrMain.DisconnMsg);        
        System.out.println("Maximum connections reached message = " + SrvrMain.MaxConnMsg +"\n");
    }
    
    private void ConfigSettings() {
    String ConfirmStr = " ";
    BufferedReader tempin;
    DataOutputStream stngsout = null;
    FileOutputStream stngsfout = null;
    boolean fileExists;
    tempin = new BufferedReader(new InputStreamReader(System.in));    
    //System.out.println("Current server settings: ");
    PrintSettings();
    File srvrstngsf = new File("SRVRSTNGS"); 
    if (srvrstngsf.exists() == true)
    {
        fileExists = true;
    }
    else
    {
        fileExists = false;
    }
    try {
            stngsfout = new FileOutputStream(srvrstngsf);
            stngsout = new DataOutputStream(stngsfout);
        }
        catch (IOException e) {
         System.out.println(e.getMessage());   
        }
    
        getSrvrPort();
        getMaxConnNum();
        getClientTimeout();
        getDBPath();
        getLogPath();
        try {
            System.out.print("\nConfirm new settings ? (yes/no): ");
            ConfirmStr = tempin.readLine();
         }
         catch (IOException e) {
          System.out.println(e.getMessage());   
         }
            if (ConfirmStr.equalsIgnoreCase("yes"))
            {
                SrvrMain.SrvrPort = SrvrMain.newSrvrPort;
                SrvrMain.MaxConnNum = SrvrMain.newMaxConnNum;
                SrvrMain.ClientTimeOut = SrvrMain.newClientTimeOut;
                SrvrMain.DBPath = SrvrMain.newDBPath;
                SrvrMain.LogPath = SrvrMain.newLogPath;
                SrvrMain.ClientsIPs = new InetAddress[SrvrMain.MaxConnNum];
                SrvrMain.ClientSock = new Socket[SrvrMain.MaxConnNum];
                try {
                stngsout.writeBytes(SrvrMain.newSrvrPort + "\n" + SrvrMain.newMaxConnNum + "\n" + SrvrMain.newClientTimeOut + "\n" + SrvrMain.newDBPath + "\n" + SrvrMain.newLogPath);                 
                stngsfout.close();
                stngsout.close();
                SrvrMain.logfout.close();
                SrvrMain.logout.close();
                }
                catch (IOException e) {
                 System.out.println(e.getMessage());   
                }
            try{
            SrvrMain.logfout = new FileOutputStream( SrvrMain.LogPath + (System.getProperty("file.separator")) + "SRVRLOG", true);
            SrvrMain.logout = new DataOutputStream(SrvrMain.logfout);
            
            }
           
    catch(IOException srvrlogferr){
           System.out.println(srvrlogferr.getMessage());
         
    }                
                System.out.println("\nSettings saved successfuly.");
                if (SrvrMain.SrvrRunning == true)
                {
                    System.out.print("\nThe service is currently running, new settings will take effect only when the service is restarted.\nrestart service now (all users will be disconnected) ? (yes/no) : ");
                    try {
                    ConfirmStr = tempin.readLine();
                    }
                    catch (IOException e) {
                     System.out.println(e.getMessage());   
                    }
                    if (ConfirmStr.equalsIgnoreCase("yes"))
                    {
                        restartSrvr();
                        System.out.println("\nService restarted.");
                        System.out.println("Settings updated successfuly.\n");
                    }
                    else
                    {
                    System.out.println("\nChanges will take effect next time service is started.");
                    System.out.println("Settings updated successfully.\n");                        
                    }
                }
                else
                {
                    System.out.println("Changes will take effect next time service is started.");
                    System.out.println("Settings updated successfully.");
                }
            }
            else
            {
                if (fileExists == true)
                {
                    try {
                stngsout.writeBytes(SrvrMain.SrvrPort + "\n" + SrvrMain.MaxConnNum + "\n" + SrvrMain.ClientTimeOut + "\n" + SrvrMain.DBPath + "\n" + SrvrMain.LogPath);                    
                    }
                    catch (IOException e) {
                        System.out.println(e.getMessage());
                    }
                System.out.println("\nNo changes were made.\n");
                }
                else
                {
                try {
                stngsout.writeBytes(SrvrMain.SrvrPort + "\n" + SrvrMain.MaxConnNum + "\n" + SrvrMain.ClientTimeOut + "\n" + SrvrMain.DBPath + "\n" + SrvrMain.LogPath);                    
                System.out.println("SRVRSTNGS file did not exist, a new one was created, and server current settings were successfuly saved to it. Newly entered settings were discarded.");
                }
                catch (IOException e) 
                {
                    System.out.println(e.getMessage());
                }
                }
                try {
                stngsfout.close();
                stngsout.close();
                }
                catch (IOException e) {
                 System.out.println(e.getMessage());   
                }
            }


    
    
    }
    
    private void ConfigMsgs() {
        String ConfirmStr;
        String newMaxConnMsg;
        String newWelcomeMsg;
        String newDisconnMsg;
        System.out.println("Current server messages: ");
    File welcomef = new File("WELCMSG");
    File disconf = new File("DISCMSG");
    File maxconf = new File("MAXCONMSG");    
    DataOutputStream welcomeout = null;
    FileOutputStream welcomefout = null;
    DataOutputStream maxconout = null;
    FileOutputStream maxconfout = null;
    DataOutputStream disconout = null;
    FileOutputStream disconfout = null;
    BufferedReader tempin = new BufferedReader(new InputStreamReader(System.in));    
        PrintMsgs();    
    try {
            welcomefout = new FileOutputStream(welcomef);
            welcomeout = new DataOutputStream(welcomefout);
            disconfout = new FileOutputStream(disconf);
            disconout = new DataOutputStream(disconfout);
            maxconfout = new FileOutputStream(maxconf);
            maxconout = new DataOutputStream(maxconfout); 
            System.out.print("Server welcome message: ");
            newWelcomeMsg = tempin.readLine();
            System.out.print("Server disconnection message: ");
            newDisconnMsg = tempin.readLine();            
            System.out.print("Server Maximum number of connection reached message: ");            
            newMaxConnMsg = tempin.readLine();  
            System.out.print("\nConfirm new messages ? (yes/no): ");            
            ConfirmStr = tempin.readLine(); 
            if (ConfirmStr.equalsIgnoreCase("yes"))
            {
                SrvrMain.WelcomeMsg = newWelcomeMsg;
                welcomeout.writeBytes(newWelcomeMsg);
                SrvrMain.MaxConnMsg = newMaxConnMsg;
                maxconout.writeBytes(newMaxConnMsg);
                SrvrMain.DisconnMsg = newDisconnMsg;
                disconout.writeBytes(newDisconnMsg);
                System.out.println("\nChanges applied successfully.\n");
            }
            else
            {
                welcomeout.writeBytes(SrvrMain.WelcomeMsg);                
                maxconout.writeBytes(SrvrMain.MaxConnMsg);                
                disconout.writeBytes(SrvrMain.DisconnMsg);                
                System.out.println("\nNo changes were made.\n");
            }
            welcomefout.close();
            welcomeout.close();
            disconfout.close();
            disconout.close();
            maxconfout.close();
            maxconout.close();
        }
        catch (IOException e) {
         System.out.println(e.getMessage());   
        }    
    }
    
    public static void getSrvrPort() {
    BufferedReader tempin = new BufferedReader(new InputStreamReader(System.in));        
           
            System.out.print("TCP/IP service port number: ");
         try {   
            SrvrMain.newSrvrPort = Integer.parseInt(tempin.readLine());
            if ((SrvrMain.newSrvrPort < 0) |  (SrvrMain.newSrvrPort > 65535))
            {
             System.out.println("Invalid TCP port number, valid TCP ports range from 1 to 65535.");
             getSrvrPort();
            }

         }
         catch (NumberFormatException e) {
             System.out.println("Invalid TCP port value, port values must be numerical.");
             getSrvrPort();
         }
         catch (IOException e) {
            System.out.println(e.getMessage());
         }        
    }
    
    public static void getMaxConnNum() {
    BufferedReader tempin = new BufferedReader(new InputStreamReader(System.in));   

            System.out.print("Maximum Number of connections allowed: ");
         try {
            SrvrMain.newMaxConnNum = Integer.parseInt(tempin.readLine());

         }
         
         catch (NumberFormatException e) {
             System.out.println("Invalid Maximum connnection number, it must be a numerical value.");
             getMaxConnNum();
         }
         catch (IOException e) {
            System.out.println(e.getMessage());
         }               
    }
    
    public static void getClientTimeout() {
    BufferedReader tempin = new BufferedReader(new InputStreamReader(System.in));  

            System.out.print("User connection timeout (in seconds): ");
         try {   
            SrvrMain.newClientTimeOut =  (Integer.parseInt(tempin.readLine()));

         }
         
         catch (NumberFormatException e) {
             System.out.println("Invalid client timeout value, must be numerical (in seconds).");
             getClientTimeout();
         }
         catch (IOException e) {
            System.out.println(e.getMessage());
         }    
    }
    
    public static void getDBPath() {
    BufferedReader tempin = new BufferedReader(new InputStreamReader(System.in));        
            System.out.print("Database path: ");
            try {
            SrvrMain.newDBPath = tempin.readLine();
            }
            catch (IOException e)
            {
                System.out.println(e.getMessage());
            }            
            File dbpath = new File(SrvrMain.newDBPath);
            if( dbpath.isDirectory() == false)
            {
                System.out.println("Invalid directory.");
                getDBPath();
            }
     }
    
    public static void getLogPath() {
    BufferedReader tempin = new BufferedReader(new InputStreamReader(System.in));        
            System.out.print("Log file path: ");
            try {
            SrvrMain.newLogPath = tempin.readLine();
            }
            catch (IOException e)
            {
                System.out.println(e.getMessage());
            }
            File logpath = new File(SrvrMain.newLogPath);
            if( logpath.isDirectory() == false)
            {
                System.out.println("Invalid directory.");
                getLogPath(); 
            }
       
    }
    
    private void AdminLongHelp() {
        String helpHelp = "help\t\tdisplays the available adminstration commands.";
        String longhelpHelp = "longhelp\tdisplays this help message.";
        String versionHelp = "version\t\tdisplays the server version.";
        String startHelp = "start\t\tstarts the service.";
        String stopHelp = "stop\t\tstops the service.";
        String restartHelp = "restart\t\truns a stop-start command sequence if the service is running, or the start command if it is not.";
        String disconnectHelp = "disconnect\tdisconnects all users.";
        String prtstngsHelp = "prtstngs\tprints the server's current settings.";
        String prtmsgsHelp = "prtmsgs\t\tprints the server's messages (the welcome, disconnection, and maximum number of connections reached messages).";
        String prtstatsHelp = "prtstats\tprints the server status (up or down, number of active connections, and details about each connection).";
        String confstngsHelp = "confstngs\tconfigure the server settings.";
        String confmsgsHelp = "confmsgs\tconfigure the server messages.";
        String quitHelp = "quit\t\tstops the service and terminates the program.";
        System.out.println("\n" + helpHelp);
        System.out.println(longhelpHelp);
        System.out.println(versionHelp);
        System.out.println(startHelp);
        System.out.println(stopHelp);
        System.out.println(restartHelp);
        System.out.println(disconnectHelp);
        System.out.println(prtstngsHelp);
        System.out.println(prtmsgsHelp);
        System.out.println(prtstatsHelp);
        System.out.println(confstngsHelp);
        System.out.println(confmsgsHelp);
        System.out.println(quitHelp + "\n");
    }
    
}
