/*
 * SrvrMain.java
 *
 * Created on July 31, 2003, 6:54 PM
 */

package SrvrTmplt;
import java.io.*;
import java.net.*;
import java.lang.*;
import java.util.*;
import java.nio.channels.*;
/**
 *
 * @author  Mohamed Medhat (www.digitalcairo.com)
 *
 * @version 1.0
 */
public class SrvrMain {
    
    public static boolean SrvrRunning;
    
    public static boolean StartSrvr = true;    
    
    static boolean KillSrvr = false;
    
    static boolean InitSuccess;
    
    static ServerSocket SrvrSock = null;
    
    static Socket[] ClientSock ;    
    
    static Socket tempsock = null;    
    
    static int SrvrPort;
    
    public static int newSrvrPort;                   
    
    static int ClientTimeOut; 
    
    public static int newClientTimeOut;    
    
    static int MaxConnNum;

    public static int newMaxConnNum;    
    
    static InetAddress[] ClientsIPs;
    
    public static volatile int NumOfSrvrThreads;
    
    static String Timestamp;
    
    static String DBPath;
    
    public static String newDBPath;    
    
    static String LogPath;
    
    public static String newLogPath;    
    
    static String LogEventDescrpt;
    
    static String cmdRcvd = "a";
    
    static String MaxConnMsg = "Sorry, maximum number of allowed connections reached, please try again later.";
    
    static String DisconnMsg = "Thanks for using server.";
    
    static String VersionMsg ;
    
    static String WelcomeMsg = "Welcome to server.";
    
    public static FileOutputStream logfout;
    
    public static DataOutputStream logout;
    
    public static final String TimeoutMsg = "Connection Timeout.";    

    public static double Version = 1.0;    
    
    /** Creates new SrvrMain */
    public SrvrMain() {
    }

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) throws IOException {
VersionMsg = "SrvrTmplt version " + Double.toString(Version);
        SrvrInit();
        if(InitSuccess == true) 
        {
            AdminThread newadmin = new AdminThread();
            newadmin.start();
            while (KillSrvr != true)
            {
            startSrvr();
            if(KillSrvr == true)
            break;
            }

                try {
                     logfout.close();
                     logout.close();
                }
                catch (IOException logcloseerr){
                 System.out.println(logcloseerr.getMessage());   
                }
                    System.exit(0);  
        }
        else
        {
            System.out.println("Could not initialize server.");
            System.exit(1);
        }
        
    }

    private static int SrvrInit() {

 // open SRVRSTNGS, read settings fields, and close SRVSTNGS.       

            File srvrstngsf = new File("SRVRSTNGS");
            if (srvrstngsf.exists() == true)
            {
                File dbpathf ;
                File logpathf;                
       try{

            FileInputStream stngsfin = new FileInputStream(srvrstngsf);
            DataInputStream stngsin = new DataInputStream(stngsfin);
            
            
            try {
            SrvrPort = Integer.parseInt(stngsin.readLine());
            MaxConnNum = Integer.parseInt(stngsin.readLine());
            ClientTimeOut = Integer.parseInt(stngsin.readLine());
            }
            catch (NumberFormatException e) {
             System.out.println("Corrupt settings file. Please delete the SRVRSTNGS file from the program home directory and re-run the server program. This will cause the execution of a new settings configuration procedure and the creation of a new SRVRSTNGS file.");
             InitSuccess = false;
             return 0;
            }
            ClientsIPs = new InetAddress[MaxConnNum];
            ClientSock = new Socket[MaxConnNum];
            int i;
            DBPath = stngsin.readLine();
            LogPath = stngsin.readLine();

                dbpathf = new File(DBPath);
                logpathf = new File(LogPath);
            if (dbpathf.isDirectory() == false | logpathf.isDirectory() == false)
            {
             System.out.println("Corrupt settings file. Please delete the SRVRSTNGS file from the program home directory and re-run the server program. This will cause the execution of a new settings configuration procedure and the creation of a new SRVRSTNGS file.");
             InitSuccess = false;
             return 0;            
            }
          
           }
           
    catch(IOException srvrstngsferr){
           System.out.println(srvrstngsferr.getMessage());

          
    }
                
                }
            else
            {
             System.out.println("Settings file does not exist, creating new one...");
        BufferedReader tempin;
        tempin = new BufferedReader(new InputStreamReader(System.in));    
        try {
            FileOutputStream stngsfout = new FileOutputStream("SRVRSTNGS");
            DataOutputStream stngsout = new DataOutputStream(stngsfout); 
            System.out.println("Running manual configuration procedure...");
            AdminThread.getSrvrPort();
            AdminThread.getMaxConnNum();
            AdminThread.getClientTimeout();
            AdminThread.getDBPath();
            AdminThread.getLogPath();
            SrvrPort = newSrvrPort;
            MaxConnNum = newMaxConnNum;
            ClientsIPs = new InetAddress[MaxConnNum];
            ClientSock = new Socket[MaxConnNum];
            ClientTimeOut = newClientTimeOut;
            DBPath = newDBPath;
            LogPath = newLogPath;
            stngsout.writeBytes(SrvrPort + "\n" + MaxConnNum + "\n" + ClientTimeOut + "\n" + DBPath + "\n" + LogPath); 
            stngsout.close();
            System.out.println("\nServer configuration complete, proceeding...\n");
        }
        catch (IOException e) {
            System.out.println(e.getMessage());
            }

            }
    
// open SRVRLOG file.
    
            try{
            logfout = new FileOutputStream( LogPath + (System.getProperty("file.separator")) + "SRVRLOG", true);
            logout = new DataOutputStream(logfout);
            }
           
    catch(IOException srvrlogferr){
           System.out.println(srvrlogferr.getMessage());
         
    }
    
// open WELCMSG file.
    
            try{
            File welcmsgf = new File("WELCMSG");
            if (welcmsgf.exists() == true)
            {            
            FileInputStream welcmsgfin = new FileInputStream(welcmsgf);
            DataInputStream welcmsgin = new DataInputStream(welcmsgfin);
            WelcomeMsg = welcmsgin.readLine();
            welcmsgin.close();
            welcmsgfin.close();
            }
            else
            {
            FileOutputStream welcmsgfout = new FileOutputStream(welcmsgf);
            DataOutputStream welcmsgout = new DataOutputStream(welcmsgfout);                
            welcmsgout.writeBytes(WelcomeMsg);   
            welcmsgfout.close();
            welcmsgout.close();             
            }
            }
           
    catch(IOException welcmsgferr){
           System.out.println(welcmsgferr.getMessage());

    }    

// open DISCMSG file.
    
            try{
            File discmsgf = new File("DISCMSG");
            if (discmsgf.exists() == true)
            {
            FileInputStream discmsgfin = new FileInputStream(discmsgf);
            DataInputStream discmsgin = new DataInputStream(discmsgfin);                
            DisconnMsg = discmsgin.readLine(); 
            discmsgin.close();         
            discmsgfin.close();
            }
            else
            {
            FileOutputStream discmsgfout = new FileOutputStream(discmsgf);
            DataOutputStream discmsgout = new DataOutputStream(discmsgfout);                
            discmsgout.writeBytes(DisconnMsg);   
            discmsgfout.close();
            discmsgout.close();             
            }
            }
           
    catch(IOException discmsgferr){
           System.out.println(discmsgferr.getMessage());
    }        
    
// open MAXCONMSG file.
    
            try{
            File maxconmsgf = new File("MAXCONMSG");
            if (maxconmsgf.exists() == true)
            {            
            FileInputStream maxconmsgfin = new FileInputStream(maxconmsgf);
            DataInputStream maxconmsgin = new DataInputStream(maxconmsgfin);
            MaxConnMsg = maxconmsgin.readLine();
            maxconmsgin.close();            
            maxconmsgfin.close();
            }
            else
            {
            FileOutputStream maxconmsgfout = new FileOutputStream(maxconmsgf);
            DataOutputStream maxconmsgout = new DataOutputStream(maxconmsgfout);                
            maxconmsgout.writeBytes(MaxConnMsg);   
            maxconmsgfout.close();
            maxconmsgout.close();       
            }
            }
           
    catch(IOException maxconmsgferr){
           System.out.println(maxconmsgferr.getMessage());
    }
                
                InitSuccess = true ;
                return 0;
    }
    
    public static void startSrvr() {
        if (StartSrvr == true)
        {

        if (SrvrRunning == true)
            System.out.println("Server already running.");
        else {
            try {
            SrvrSock = new ServerSocket(SrvrPort);
            SrvrRunning = true;
            }
            catch (IOException socketerr) {
                System.out.println(socketerr.getMessage());
            }
            LogEventDescrpt = "server started." ;
            AddToLog();
                try {
                   SrvrSock.setSoTimeout(10);      
                }
                catch (SocketException e)
                {
                    System.out.println(e.getMessage());
                }            
            while (SrvrRunning == true)
            {

 
                if (KillSrvr == true)
                    break;
                else
                {

                   if ( NumOfSrvrThreads == MaxConnNum )
                {

                    try {
 
                   tempsock = SrvrSock.accept();
                   PrintWriter tempout = new PrintWriter(tempsock.getOutputStream() , true);
                   tempout.println(MaxConnMsg);
                   tempout.close();
                   tempsock.close();  
                    }
                    catch (IOException e){
                        //System.out.println(e.getMessage());
                    }

                }
 
                else
                {
                    try {
                 ClientThread newsrvr = new ClientThread(SrvrSock.accept());
                 NumOfSrvrThreads++;
                 newsrvr.start();
                    }
                    catch (IOException e){
                        //System.out.println(e.getMessage());
                    }
                }
                    


                }

            }
        }
        }
        else;
    }
    
    public static void stopSrvr() {
               if (SrvrRunning == false)
            System.out.println("Server already stopped.");
        else {
            if (NumOfSrvrThreads != 0)
            SrvrTmplt.AdminThread.DisconnectAll();
            SrvrRunning = false;  
            StartSrvr = false;

            try {
            SrvrSock.close();
            }
            catch (IOException socketerr) {
                System.out.println(socketerr.getMessage());
            }
           // System.out.println("Server stopped.");
            LogEventDescrpt = "server stopped." ;
            AddToLog();

        }
            
    }
    
    public static void AddToLog() {
        Timestamp = new Date(System.currentTimeMillis()).toLocaleString();
        try {
        logout.writeBytes(Timestamp + " " + LogEventDescrpt + "\n");
  
        }
        catch (IOException logerr){
            System.out.println(logerr.getMessage());
        }
    }
    

}
